# Version
# Raspberry Pi Pico Keyboard Passeord Tresor
#Rotary encoder Pressbutton & Rotary GND to ground
#Pressbutton  D7
#A pin on the rotary encoder D8
#B pin on the rotary encoder D9

#Declarations
import time
import board
import digitalio
import os
import busio
import storage
import rotaryio
import adafruit_ssd1306
import adafruit_sdcard
import microcontroller

#GPIO SETUP
encoder = rotaryio.IncrementalEncoder(board.GP9, board.GP8)
last_position = None
ledRed = digitalio.DigitalInOut(board.GP4)
ledRed.direction = digitalio.Direction.OUTPUT
ledBlue = digitalio.DigitalInOut(board.GP3)
ledBlue.direction = digitalio.Direction.OUTPUT
ledGreen = digitalio.DigitalInOut(board.GP2)
ledGreen.direction = digitalio.Direction.OUTPUT
btn_Select = digitalio.DigitalInOut(board.GP7)
btn_Select.direction = digitalio.Direction.INPUT
btn_Select.pull = digitalio.Pull.UP

SDA = board.GP14
SCL = board.GP15
i2c = busio.I2C(SCL, SDA)
oled = adafruit_ssd1306.SSD1306_I2C(128, 32, i2c)

# DELAY FOR BOOTUP START
Boot = 0
oled.fill(0)
oled.text(str("BOOTING NOW"), 10, 15, 1)
oled.show()
print("BOOT DELAY 3Min")
while Boot < 600:
    if (btn_Select.value == 0):
        Boot = 599
    Boot = Boot + 1
    ledRed.value = True
    time.sleep(0.05)
    ledRed.value = False
    time.sleep(0.05)
    ledBlue.value = True
    time.sleep(0.05)
    ledBlue.value = False
    time.sleep(0.05)
    ledGreen.value = True
    time.sleep(0.05)
    ledGreen.value = False
    time.sleep(0.05)
# DELAY FOR BOOTUP END

import usb_hid
from adafruit_hid.keyboard import Keyboard
from adafruit_hid.keyboard_layout_us import KeyboardLayoutUS
from adafruit_hid.keycode import Keycode
kbd = Keyboard(usb_hid.devices)
keyboard = Keyboard(usb_hid.devices)
keyboard_layout = KeyboardLayoutUS(keyboard)


# Use any pin that is not taken by SPI
SD_CS = board.GP13

# Connect to the card and mount the filesystem.
spi = busio.SPI(board.GP10, board.GP11, board.GP12)
cs = digitalio.DigitalInOut(SD_CS)
sdcard = adafruit_sdcard.SDCard(spi, cs)
vfs = storage.VfsFat(sdcard)
storage.mount(vfs, "/sd")

counter = 0
anzahlPW = 0
iText = ""
Version = "2.0"

oled.fill(0)
oled.text(str("PASSWORT - TRESOR"),0, 2, 1)
oled.text(str("Version: "), 0, 15, 1)
oled.text(str(Version), 50, 15, 1)
time.sleep(2)
oled.text(str("KEINE DATENBANK!"), 0, 25, 1)
oled.show()
time.sleep(0.3)

# SUB LINKS


def readPW():
    #print("SWITCH ON LED RED")
    noLED()
    ledRed.value = True
    printer = 0
    global counter
    global anzahlPW
    global iText
    anzahlPW = 0
    with open("/sd/PWData.txt") as file:
        #print("Printing lines in file:")
        selectStart = "PWSTART" + str(counter)
        selectEnd = "PWEND" + str(counter)
        for line in file:
            if line.strip() == selectEnd:
                #print("Ending Printint now")
                encoder.position = 0
                time.sleep(0.01)
                printer = 0
            if printer == 1:
                i=0
                charText = line.strip()
                while i < len(charText):
                    iText = (charText[i])
                    charTest()
                    if ( iText.isupper()):
                        #print("CAPITALIZED")
                        kbd.press(Keycode.SHIFT)
                        keyboard_layout.write(iText)
                        kbd.release_all()
                        iText = ""
                    keyboard_layout.write(iText)
                    i += 1
                    time.sleep(0.01)
                #keyboard_layout.write(line.strip())
                #keyboard.send(Keycode.ENTER)
                time.sleep(0.01)
                while btn_Select.value == 1:
                    #print("Waiting for Button")
                    #print("SWITCH ON LED BLUE")
                    noLED()
                    ledBlue.value = True
                    time.sleep(0.01)
            if line.strip() == selectStart:
               # print("Starting Printint now")
                printer = 1
                time.sleep(0.01)
            if(line.startswith('PWSTART')):
               # print("Start ok")
                anzahlPW = anzahlPW + 1
            #print(line, end='')
            #print(selectStart)
    file.close
def noLED():
    ledRed.value = False
    ledBlue.value = False
    ledGreen.value = False

def charTest():
    noLED()
    ledRed.value = True
    global iText
   #print (iText)
    swapchar = iText
    if swapchar == "Z":
        iText = "Y"
    if swapchar == "Y":
        iText = "Z"
    if swapchar == "z":
        iText = "y"
    if swapchar == "y":
        iText = "z"
    if swapchar == "!":
        iText = "}"
    if swapchar == "?":
        iText = "_"
    if swapchar == ":":
        iText = ">"
    if swapchar == "_":
        iText = "?"
    if swapchar == "$":
        kbd.press(Keycode.POUND)
        kbd.release_all()
        iText = ""    
    if swapchar == "&":
        kbd.press(Keycode.SHIFT, Keycode.SIX)
        kbd.release_all()
        iText = ""     
    if swapchar == ")":
        kbd.press(Keycode.SHIFT, Keycode.NINE)
        kbd.release_all()
        iText = ""       
    if swapchar == "(":
        kbd.press(Keycode.SHIFT, Keycode.EIGHT)
        kbd.release_all()
        iText = ""     
    if swapchar == "@":
        kbd.press(Keycode.RIGHT_ALT, Keycode.TWO)
        kbd.release_all()
        iText = ""
    if swapchar == "#":
        kbd.press(Keycode.RIGHT_ALT, Keycode.THREE)
        kbd.release_all()
        iText = ""

    if swapchar == "+":
        kbd.press(Keycode.SHIFT, Keycode.ONE) # +
        kbd.release_all()
        iText = ""
    if swapchar == '"':
        kbd.press(Keycode.SHIFT, Keycode.TWO) # "
        kbd.release_all()
        iText = ""
    if swapchar == "*":
        kbd.press(Keycode.SHIFT, Keycode.THREE) # *
        kbd.release_all()
        iText = ""
#    if swapchar == "ç":
#        kbd.press(Keycode.SHIFT, Keycode.FOUR) # ç
#        kbd.release_all()
#        iText = ""
    if swapchar == "%":
        kbd.press(Keycode.SHIFT, Keycode.FIVE) # %
        kbd.release_all()
        iText = ""
    if swapchar == "/":
        kbd.press(Keycode.SHIFT, Keycode.SEVEN) # /
        kbd.release_all()
        iText = ""
    if swapchar == "=":
        kbd.press(Keycode.SHIFT, Keycode.ZERO) # =
        kbd.release_all()
        iText = ""
    if swapchar == "¦":
        kbd.press(Keycode.RIGHT_ALT, Keycode.ONE) # ¦
        kbd.release_all()
        iText = ""
    if swapchar == "°":
        kbd.press(Keycode.RIGHT_ALT, Keycode.FOUR) # °
        kbd.release_all()
        iText = ""
    if swapchar == "§":
        kbd.press(Keycode.RIGHT_ALT, Keycode.FIVE) # §
        kbd.release_all()
        iText = ""
    if swapchar == "¬":
        kbd.press(Keycode.RIGHT_ALT, Keycode.SIX) # ¬
        kbd.release_all()
        iText = ""
    if swapchar == "|":
        kbd.press(Keycode.RIGHT_ALT, Keycode.SEVEN) # |
        kbd.release_all()
        iText = ""
    if swapchar == "¢":
        kbd.press(Keycode.RIGHT_ALT, Keycode.EIGHT) # ¢
        kbd.release_all()
        iText = ""
    if swapchar == "£":
        kbd.press(Keycode.SHIFT, Keycode.BACKSLASH) # £
        kbd.release_all()
        iText = ""
    if swapchar == ",":
        kbd.press(Keycode.COMMA) #  ,
        kbd.release_all()
        iText = ""
    if swapchar == ";":
        kbd.press(Keycode.SHIFT, Keycode.COMMA) #  ;
        kbd.release_all()
        iText = ""
##    if swapchar == "^":
##        kbd.press(Keycode.EQUALS) # ^
##        kbd.release_all()
##        iText = ""
##    if swapchar == "`":
##        kbd.press(Keycode.SHIFT, Keycode.EQUALS) # ` 
##        kbd.release_all()
##        iText = ""
    if swapchar == "-":
        kbd.press(Keycode.FORWARD_SLASH) # -
        kbd.release_all()
        iText = ""
#    if swapchar == "§":
#        kbd.press(Keycode.GRAVE_ACCENT) # §
#        kbd.release_all()
#        iText = ""
    if swapchar == "<":
        kbd.press(Keycode.KEYPAD_BACKSLASH) # <
        kbd.release_all()
        iText = ""
    if swapchar == ".":
        kbd.press(Keycode.PERIOD) # .
        kbd.release_all()
        iText = ""
    if swapchar == "ü":
        kbd.press(Keycode.LEFT_BRACKET) # ü
        kbd.release_all()
        iText = ""
    if swapchar == "'":
        kbd.press(Keycode.MINUS) # '
        kbd.release_all()
        iText = ""
    if swapchar == "ä":
        kbd.press(Keycode.QUOTE) # ä
        kbd.release_all()
        iText = ""
    if swapchar == "é":
        kbd.press(Keycode.SHIFT, Keycode.SEMICOLON) # Ö
        kbd.release_all()
        iText = ""


readPW()                             #get number of PW
#print ("PWCount ", anzahlPW)
#print ("INIT OK")
oled.fill(0)
oled.text("INIT DONE", 0, 0, 1)
oled.text("PASSWOERTER: ", 0, 12, 1)
oled.text(str(anzahlPW), 80, 12, 1)
oled.show()
time.sleep(1)


# ____________________
#   MAIN PROGRAMM
# ____________________
x = 0
y = 0
with open("/sd/PWData.txt") as f:
    content_list = f.readlines()

size = len(content_list)

for item in content_list:
    if(content_list[x].startswith('PWSTART')):
        content_list[y] = content_list[x - 1]
        y += 1
    x += 1
f.close
# print("In the loop now")

while True:
    noLED()
    ledGreen.value = True
    #print("SWITCH ON LED GREEN")
    if btn_Select.value == 0:
        # print("Button Pressed")
        print(counter)
        time.sleep(0.5)
        readPW()
    position = encoder.position
    if position < 0:
        position = 0
        encoder.position = 0
    if position > anzahlPW:
        position = anzahlPW
        encoder.position = anzahlPW
    counter = position
    if last_position is None or position != last_position:
        print("Position",position)
        oled.fill(0)
        index = content_list[position - 1]
        oled.text(index.strip(), 0, 12, 1)
        oled.show()

    last_position = position
